package Omann_Ru {
//begin Omann_Ru package ------------------------------------------

function orSetup()
{
   //
   exec("scripts/OR_mpb.cs");//load the modified mpb functions
   exec("scripts/OR_camera.cs");//exec 1 modified function to fix observer camera spam

   //set mission cleanup for game over ------ * HACK ALERT! - We Hack around MapSupportPack Here :) *
   exec("scripts/OR_MissionOver.cs");//needed to set server back to default while using MapSupportPack

   if ($Host::BotsEnabled)
   {
      %gravity = getGravity();
      if (%gravity == -20)
      {
         error("Server Bots Enabled");
         error("Loading Lagg's... custom AI files :)");

         //exec all the modified ai scripts
         exec("scripts/aiOR.cs");
         // includes                           exec("scripts/aiOR_DefaultTasks.cs");
         // includes                           exec("scripts/aiOR_Objectives.cs");
         // includes                           exec("scripts/aiOR_Inventory.cs");
         // includes                           exec("scripts/aiOR_Chat.cs");
         // includes                           exec("scripts/aiOR_ObjectiveBuilder.cs");
         // includes                           exec("scripts/aiOR_EscortPlayer.cs");
         // includes                           exec("scripts/OR_serverTasks.cs");
         // includes                           exec("scripts/aiOR_vehicle.cs");

         //exec all the modifed ai support files
         exec("scripts/aiOR_Siege.cs");//exec 2 modified functions from aiSiege.cs
         exec("scripts/aiOR_projectiles.cs");//exec 2 modified functions from projectiles.cs
         exec("scripts/aiOR_player.cs");//exec modified function Armor::onCollision to allow medium bots to pilot vehicles
         exec("scripts/aiOR_turret.cs");//allows turrets to fire at all enemy targets
         exec("scripts/aiOR_Support.cs");//2 added functions for mortar/plasma turret fire, 2 spam fixes
         exec("scripts/aiOR_VehicleSupport.cs");//modified bomber/tank data blocks, modified MPB jammer,
                                               //     2 spam fixes for ai dismounting bomber and tank

         activatePackage(aiOR_Support);
         echo("Activating Package aiOR_Support");

         GameStartUp();//call this after Ai files are loaded - NOTE *
      }
      else
         error("Server Gravity not set to default - Aborting Custom AI Setup :(");
   }
   else
      error("Server Bots Disabled - Aborting Custom AI Setup :(");
}

function StaticShapeData::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   //No base items are destroyable if team 1
   if (%targetObject == nameToId("Team1StationInventory1") || %targetObject == nameToId("Team1StationInventory2")
     || %targetObject == nameToId("Team1StationInventory3") || %targetObject == nameToId("Team1StationInventory4")
     || %targetObject == nameToId("Team1TurretBaseLarge1") || (%data.noDamageInSiege && Game.class $= "SiegeGame"))
   {

      if(%sourceObject && %targetObject.isEnabled())
      {
         if(%sourceObject.client)
            messageClient(%sourceObject.client, 0, "\c5Offensive Base Equipment Invincible.~wfx/powered/station_denied.wav");
      }
      return;
   }

   Parent::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType);
}

function SiegeGame::missionLoadDone(%game)
{
   Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;

   nameToId("RoadSide1").sphereWeight = 60;
   nameToId("RoadSide2").sphereWeight = 0;
   nameToId("RoadSide3").sphereWeight = 30;
   nameToId("Main").sphereWeight = 10;

   $InvBanList[Siege, "SatchelCharge"] = 1;
	
   Parent::missionLoadDone(%game);
}

// Swap good spheres out and bad ones in if power is down
function Generator::onDisabled(%data, %obj)
{
   Parent::onDisabled(%data, %obj);

   if (! nameToId("Bunker").getGroup().powerCount == 0 )
      return;

   if (%obj == nameToId("Team2GeneratorLarge1") || %obj == nameToId("Team2GeneratorLarge2"))
   {
		
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
            bottomPrint(%client, "<color:FF0000>\Bunker Gens Destroyed: Emergency Spawnsphere Activated", 5, 1);
         else if (%client.team == Game.offenseTeam)
            bottomPrint(%client, "<color:8BBD03>\Bunker Gens Destroyed: Main Base Access Granted", 5, 1);
      }

      nameToId("RoadSide1").sphereWeight = 0;
      nameToId("RoadSide2").sphereWeight = 65;
      nameToId("RoadSide3").sphereWeight = 0;
      nameToId("Main").sphereWeight = 35;
   }
}

//pimary spawnsphere active if gens are enabled
function Generator::onEnabled(%data, %obj, %prevState)
{
   Parent::onEnabled(%data, %obj, %prevState);
	
   if (nameToId("Bunker").getGroup().powerCount == 2 )
      return;

   if (%obj == nameToId("Team2GeneratorLarge1") || %obj == nameToId("Team2GeneratorLarge2"))
   {	
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
            bottomPrint(%client, "<color:8BBD03>\Bunker Gens Restored: Primary Spawnspheres Reactivated", 5, 1);
         else if (%client.team == Game.offenseTeam)
            bottomPrint(%client, "<color:FF0000>\Bunker Gens Restored: Main Base Access Denied", 5, 1);
      }

      nameToId("RoadSide1").sphereWeight = 60;
      nameToId("RoadSide2").sphereWeight = 0;
      nameToId("RoadSide3").sphereWeight = 30;
      nameToId("Main").sphereWeight = 10;
   }
}

function SiegeGame::halftime(%game, %reason)
{
   //reset spwan sphere weights
   nameToId("RoadSide1").sphereWeight = 60;
   nameToId("RoadSide2").sphereWeight = 0;
   nameToId("RoadSide3").sphereWeight = 30;
   nameToId("Main").sphereWeight = 10;

   echo("SiegeGame::halftime - Spawn sphere weights reset");
   Parent::halftime(%game, %reason);

   //clear bottom print messages
   clearBottomPrintAll();
}

function SiegeGame::halftimeOver(%game)
{	
   Parent::halftimeOver(%game);

   //call after parent to set up ai vehicle functions for second half - Lagg... 10-2-2003   
   SweepForPads(NameToID(MissionGroup));
}



function SiegeGame::objectSwapVehiclePads(%game, %this)
{
   %defTeam = %game.offenseTeam == 1 ? 2 : 1;

   if(%this.getDatablock().getName() $= "StationVehicle")
   {
      if(%this.getTarget() != -1)
      {
         // swap the teams of both the vehicle pad and the vehicle station
         if(getTargetSensorGroup(%this.getTarget()) == %game.offenseTeam)
         {
            setTargetSensorGroup(%this.getTarget(), %defTeam);
            %this.team = %defTeam;
            setTargetSensorGroup(%this.pad.getTarget(), %defTeam);
            %this.pad.team = %defTeam;
            // z0dd - ZOD, 4/20/02. Switch the teleporter too.
            setTargetSensorGroup(%this.teleporter.getTarget(), %defTeam);
            %this.teleporter.team = %defTeam;
         }
         else if(getTargetSensorGroup(%this.getTarget()) == %defTeam)
         {
            setTargetSensorGroup(%this.getTarget(), %game.offenseTeam);
            %this.team = %game.offenseTeam;
            setTargetSensorGroup(%this.pad.getTarget(), %game.offenseTeam);
            %this.pad.team = %game.offenseTeam;
            // z0dd - ZOD, 4/20/02. Switch the teleporter too.
            setTargetSensorGroup(%this.teleporter.getTarget(), %game.offenseTeam);
            %this.teleporter.team = %game.offenseTeam;
         }
      }
   }
}

//siege game spam fix
function SiegeGame::vehicleDestroyed(%game, %vehicle, %destroyer)
{
  //needed to prevent Siege Game consol spam - Lagg... 11-12-2003   
}

//--------------------------------------------------------------------------------
//spam fix for MPB Vehicle on Blow UP
//the problem is the MPB forcefield shield is not mounted to vehicle object,
//We could rewrite the MPB or just do a little fix here this way. Note if two
//MPB's are fully deployed next to each other and one blows up you will encounter spam, but
//what is the chance of that happening? heh, heh  - Lagg... 11-12-2003
function radiusVehicleExplosion(%data, %vehicle)
{
	// this is a modified version of RadiusExplosion() from projectiles.cs
	%position = %vehicle.getPosition();

   //removed ForceFieldObjectType below to stop spam
   //trying to figure out why it was there in the first place
   //can't apply damage to a ff and we check for ff later 
   //to see if you are protected by one - Lagg... 11-12-2003
   //InitContainerRadiusSearch(%position, %data.explosionRadius, $TypeMasks::PlayerObjectType      |
                                                 //$TypeMasks::VehicleObjectType     |
                                                 //$TypeMasks::MoveableObjectType    |
                                                 //$TypeMasks::StaticShapeObjectType |
                                                 //$TypeMasks::ForceFieldObjectType  |
                                                 //$TypeMasks::TurretObjectType      |
                                                 //$TypeMasks::ItemObjectType);
   InitContainerRadiusSearch(%position, %data.explosionRadius, $TypeMasks::PlayerObjectType      |
                                                 $TypeMasks::VehicleObjectType     |
                                                 $TypeMasks::MoveableObjectType    |
                                                 $TypeMasks::StaticShapeObjectType |
                                                 $TypeMasks::TurretObjectType      |
                                                 $TypeMasks::ItemObjectType);

   %numTargets = 0;
   while ((%targetObject = containerSearchNext()) != 0)
   {
		if(%targetObject == %vehicle)
			continue;

      //%name = %targetObject.getDataBlock().getName();
      //error("function radiusVehicleExplosion - targetObject = " @ %name);
      //if (%targetObject == %vehicle.shield)
         //error("YES IT IS THE MPB's SHIELD");

      %dist = containerSearchCurrRadDamageDist();

      if (%dist > %data.explosionRadius)
         continue;

      //we checked if explosion source was the vehicle, now check for parts of same vehicle - Lagg... 11-12-2003
      if (%targetObject.isMounted())
      //if (%targetObject != %vehicle.shield && %targetObject.isMounted())
      {
         %mount = %targetObject.getObjectMount();
			if(%mount == %vehicle)
				continue;

         %found = -1;
         for (%i = 0; %i < %mount.getDataBlock().numMountPoints; %i++)
         {
            if (%mount.getMountNodeObject(%i) == %targetObject)
            {
               %found = %i;
               break;
            }
         }
      
         if (%found != -1)
         {
            if (%mount.getDataBlock().isProtectedMountPoint[%found] && (%mount != %vehicle))
               continue;
         }
      }

      %targets[%numTargets]     = %targetObject;
      %targetDists[%numTargets] = %dist;
      %numTargets++;
   }

   for (%i = 0; %i < %numTargets; %i++)
   {
      %targetObject = %targets[%i];
      %dist = %targetDists[%i];

      %coverage = calcExplosionCoverage(%position, %targetObject,
                                        ($TypeMasks::InteriorObjectType |
                                         $TypeMasks::TerrainObjectType |
                                         $TypeMasks::ForceFieldObjectType));
      if (%coverage == 0)
         continue;

      %amount = (1.0 - (%dist / %data.explosionRadius)) * %coverage * %data.explosionDamage;
      %targetData = %targetObject.getDataBlock();

      %momVec = "0 0 1";
      
      if(%amount > 0)
         %targetData.damageObject(%targetObject, %sourceObject, %position, %amount, $DamageType::Explosion, %momVec);
   }
}

//end Omann_Ru package --------------------------------------------
};

function GameStartUp()
{
   $ObjectiveCounter[1] = 0;
   $ObjectiveCounter[2] = 0;
 
   if ($missionRunning == false)
   {
      schedule(500, 0, GameStartUp);
      return;
   }
   SweepForPads(NameToID(MissionGroup)); 
}

function SweepForPads(%simGroup)
{
   if(%SimGroup.getClassName() $= "SimGroup")
   {
      for (%i = 0; %i < %SimGroup.getCount(); %i++)
      {
         %obj = %SimGroup.getObject(%i);
         if (%obj.getClassName() $= "SimGroup")
         {
            SweepForPads(%obj);
         }
 
         if (%obj.getClassName() $= "StaticShape")
         {
            if (%obj.getDataBlock().getName() $= "StationVehicle")
            {
               //addVPadObjective(%obj);//funtion not included in this map :(
                $AIVehiclePadSet.add(%obj);
            }
            if (%obj.getDataBlock().getName() $= "MPBTeleporter")
            {
               //addVPadObjective(%obj);//funtion not included in this map :(
               $AITeleportSet.add(%obj);
            }
         } 
      }
   }
}





